
/*
 * 日期的一些简单方法
 * 日期格式为yyyy-MM-ddTHH:mm:ss
 */

//获取时间部分
function getTime(date){
	var reg = /[0-9]{4}-[0-9]{2}-[0-9]{2}T([0-9]{2}:[0-9]{2})/g ;
	var ret = reg.exec(date) ; 
	if( ret!== null && ret.length === 2 ){
		return ret[1] ; 
	}
	return null ; 
}

//获取日期部分
function getDay(date){
	var reg = /([0-9]{4}-[0-9]{2}-[0-9]{2})T[0-9]{2}:[0-9]{2}/g ;
	var ret = reg.exec(date) ; 
	if( ret!== null && ret.length === 2 ){
		return ret[1] ; 
	}
	return null ; 
}

//获取今天
function getDayStr(d){
	var str = d.getFullYear() + '-' + append0(d.getMonth()+1, 2) + '-' + append0(d.getDate(), 2) ; 
	return str ; 
}

//加0
//@param count 总共的位数
function append0(s, count){
	if( s === null || count <= 0 ){
		return null ; 
	}
	var str = '' + s ; 
	var ct = count - str.length ; 
	//获取0
	var str0 = '' ; 
	for(var i = 0; i < ct; i++){
		str0 += '0' ; 
	}
	return str0+str ; 
}

//获取明天
function getTomorrow(){
	var cd = new Date() ; 
	var td = new Date(cd.getTime() + 24*60*60*1000) ;
	return getDayStr(td) ; 
}

//获取今天
function getToday(){
	return getDayStr(new Date()) ; 
}

//获取日期描述
function getDayDesc(day){
	//是否是今天
	var desc = '' ; 
	if( day === getToday() ){
		desc = '今天' ; 
	}else if( day === getTomorrow() ){
		desc = '明天' ; 
	}
	if( desc === '' ){
		desc = day ; 
	}
	return desc ; 
}



